// Author: Jason Newell
// Company: The Charles Machine Works, Inc.
// This class is a partial port from ShObjIdl.h.
// file://C:/Program%20Files/Microsoft%20Visual%20Studio%20.NET%202003/Vc7/PlatformSDK/Include/ShObjIdl.h

using System;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Text;

namespace Microsoft.Win32
{
	[Flags]
	public enum SHCONTF : int
	{
		SHCONTF_FOLDERS = 32,
		SHCONTF_NONFOLDERS = 64,
		SHCONTF_INCLUDEHIDDEN = 128
	}

	[Flags]
	public enum SHGDNF : int
	{
		SHGDN_NORMAL = 0,
		SHGDN_INFOLDER = 1,
		SHGDN_FORADDRESSBAR = 16384,
		SHGDN_FORPARSING = 32768
	}

	[Flags]
	public enum SFGAO : int
	{
		SFGAO_CANCOPY = 1,
		SFGAO_CANMOVE = 2,
		SFGAO_CANLINK = 4,
		SFGAO_CANRENAME = 16,
		SFGAO_CANDELETE = 32,
		SFGAO_HASPROPSHEET = 64,
		SFGAO_DROPTARGET = 256,
		SFGAO_CAPABILITYMASK = 375,
		SFGAO_LINK = 65536,
		SFGAO_SHARE = 131072,
		SFGAO_READONLY = 262144,
		SFGAO_GHOSTED = 524288,
		SFGAO_DISPLAYATTRMASK = 983040,
		SFGAO_FILESYSANCESTOR = 268435456,
		SFGAO_FOLDER = 536870912,
		SFGAO_FILESYSTEM = 1073741824,
		SFGAO_HASSUBFOLDER = -2147483648,
		SFGAO_CONTENTSMASK = -2147483648,
		SFGAO_VALIDATE = 16777216,
		SFGAO_REMOVABLE = 33554432,
		SFGAO_COMPRESSED = 67108864
	}

	public enum IEIFLAG
	{
		IEIFLAG_ASYNC       = 0x0001,      // ask the extractor if it supports ASYNC extract (free threaded)
		IEIFLAG_CACHE       = 0x0002,      // returned from the extractor if it does NOT cache the thumbnail
		IEIFLAG_ASPECT      = 0x0004,      // passed to the extractor to beg it to render to the aspect ratio of the supplied rect
		IEIFLAG_OFFLINE     = 0x0008,      // if the extractor shouldn't hit the net to get any content neede for the rendering
		IEIFLAG_GLEAM       = 0x0010,     // does the image have a gleam ? this will be returned if it does
		IEIFLAG_SCREEN      = 0x0020,      // render as if for the screen  (this is exlusive with IEIFLAG_ASPECT )
		IEIFLAG_ORIGSIZE    = 0x0040,      // render to the approx size passed, but crop if neccessary
		IEIFLAG_NOSTAMP     = 0x0080,      // returned from the extractor if it does NOT want an icon stamp on the thumbnail
		IEIFLAG_NOBORDER    = 0x0100,      // returned from the extractor if it does NOT want an a border around the thumbnail
		IEIFLAG_QUALITY     = 0x0200      // passed to the Extract method to indicate that a slower, higher quality image is desired, re-compute the thumbnail
	}

	[ComImportAttribute()]
	[GuidAttribute("000214F2-0000-0000-C000-000000000046")]
	[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]		
	public interface IEnumIDList
	{
		[PreserveSig]
		int Next(
			int celt, 
			ref IntPtr rgelt, 
			out int pceltFetched);

		void Skip(
			int celt);

		void Reset();
    
		void Clone(
			ref IEnumIDList ppenum);
	};

	[ComImportAttribute()]
	[GuidAttribute("000214E6-0000-0000-C000-000000000046")]
	[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]		
	public interface IShellFolder
	{
		void ParseDisplayName(
			IntPtr hwndOwner, 
			IntPtr pbcReserved, 
			[MarshalAs(UnmanagedType.LPWStr)] string lpszDisplayName,
			out int pchEaten, 
			out IntPtr ppidl, 
			out int pdwAttributes);

		void EnumObjects(
			IntPtr hwndOwner, 
			[MarshalAs(UnmanagedType.U4)] SHCONTF grfFlags,
			ref IEnumIDList ppenumIDList
			);

		void BindToObject(
			IntPtr pidl, 
			IntPtr pbcReserved, 
			ref Guid riid, 
			ref IShellFolder ppvOut);

		void BindToStorage(
			IntPtr pidl, 
			IntPtr pbcReserved, 
			ref Guid riid, 
			IntPtr ppvObj
			);

		[PreserveSig]
		int CompareIDs(
			IntPtr lParam, 
			IntPtr pidl1, 
			IntPtr pidl2);

		void CreateViewObject(
			IntPtr hwndOwner, 
			ref Guid riid, 
			IntPtr ppvOut);

		void GetAttributesOf(
			int cidl, 
			IntPtr apidl, 
			[MarshalAs(UnmanagedType.U4)] ref SFGAO rgfInOut); 

		void GetUIObjectOf(
			IntPtr hwndOwner, 
			int cidl, 
			ref IntPtr apidl, 
			ref Guid riid, 
			out int prgfInOut, 
			ref IUnknown ppvOut);

		void GetDisplayNameOf(
			IntPtr pidl, 
			[MarshalAs(UnmanagedType.U4)] SHGDNF uFlags,
			ref STRRET_CSTR lpName);			

		void SetNameOf(
			IntPtr hwndOwner, 
			IntPtr pidl,
			[MarshalAs(UnmanagedType.LPWStr)] string lpszName,
			[MarshalAs(UnmanagedType.U4)] SHCONTF uFlags,
			ref IntPtr ppidlOut);
	};

	[ComImportAttribute()]
	[GuidAttribute("BB2E617C-0920-11d1-9A0B-00C04FC2D6C1")]
	[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
	//helpstring("IExtractImage"),
	public interface IExtractImage
	{
		void GetLocation(
			[Out(), MarshalAs(UnmanagedType.LPWStr)] StringBuilder pszPathBuffer,
			int cch,
			ref int pdwPriority,
			ref Size prgSize,
			int dwRecClrDepth,
			ref int pdwFlags);

		void Extract(
			out IntPtr phBmpThumbnail);
	}
}
